#-*- coding: utf-8 -*-
from config import MainConfig
import pmloader
from direct.directbase import DirectStart


class PMCore():
    comdir = "components"
    modules = []
    comlist = {}
    global_dictionary = {}
    global_config = MainConfig()
    def __init__(self):
        self.global_config.read("config")
        pmloader.load_components(self.comdir,"restrict.lst",self.modules, self.comlist)
        
        for c in self.comlist.values():
            print self.global_config.get_module_options(c.name)
            c.set_start_settings(self.global_config.get_module_options(c.name))
            c.set_global_dictionary(self.global_dictionary)
            
        for c in self.comlist.values():
            c.before_direct_import()

        from direct.directbase import DirectStart

        for c in self.comlist.values():
            c.after_direct_import()
            
        if self.global_dictionary.has_key("base_mouse"):
            if not self.global_dictionary["base_mouse"]: base.disableMouse()
