#-*- coding: utf-8 -*-

import os
import inspect
import components.basecom


def load_components(comdir,restrictfile,modules,comlist):
    # Load list of restrict modules
    f=open(comdir+"/"+restrictfile)
    restrict = f.readlines()
    for i in xrange(len(restrict)):
        restrict[i] = restrict[i].replace("\n","")
        restrict[i] = restrict[i].replace("\r","")
    print restrict
    f.close()

    # Перебираем файлы в папке components
    for fname in os.listdir(comdir):
        if fname.endswith (".py"):
            module_name = fname[: -3]
            if module_name not in restrict:
                print "Load module %s" % module_name
                # Загружаем модуль и добавляем его имя в список загруженных модулей
                package_obj = __import__(comdir + "." +  module_name)
                modules.append (module_name)
                #print "dir(package_obj) = " + str (dir(package_obj) )
                print
            else:
                print "Skip " + fname

    # Перебираем загруженные модули
    for modulename in modules:
        module_obj = getattr (package_obj, modulename)
        #print modulename
        #print dir (module_obj)
        # Перебираем все, что есть внутри модуля
        for elem in dir (module_obj):
            obj = getattr (module_obj, elem)
            # Это класс?
            if inspect.isclass (obj):
                # Класс производный от baseplugin?
                if issubclass (obj, components.basecom.BaseComponent):
                    o = obj()
                    if o.name not in comlist:
                        comlist[o.name] = o
                        print "DONE: component " + o.name + "\n"
                    else:
                        print "ERROR: Duplicate component name\n"
                    #a.run()
                    print
    #print dir(comlist)

